Qore::HashKeyIterator Class Reference

This class an iterator class for hashes. More...

Inheritance diagram for Qore::HashKeyIterator:
[legend]

## Public Member Functions

| constructor (hash h)
| Creates the hash iterator object. More...
| constructor ()
| Creates an empty hash iterator object. More...
| copy ()
| Creates a copy of the HashKeyIterator object, iterating the same object as the original and in the same position. More...
string | getValue ()
| returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
Public Member Functions inherited from Qore::HashIterator
| constructor (hash h)
| Creates the hash iterator object. More...
| constructor ()
| Creates an empty hash iterator object. More...
| copy ()
| Creates a copy of the HashIterator object, iterating the same object as the original and in the same position. More...
bool | empty ()
| returns True if the hash is empty; False if not More...
bool | first ()
| returns True if on the first element of the hash More...
string | getKey ()
| returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
any | getKeyValue ()
| returns the current value of the current hash key being iterated or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
hash | getValuePair ()
| returns a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
bool | last ()
| returns True if on the last element of the hash More...
bool | next ()
| Moves the current position to the next element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the first element in the hash if the hash is not empty. More...
bool | prev ()
| Moves the current position to the previous element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the last element in the hash if the hash is not empty. More...
| reset ()
| Reset the iterator instance to its initial state. More...
bool | valid ()
| returns True if the iterator is currently pointing at a valid element, False if not More...

## Detailed Description

This class an iterator class for hashes.

Call HashKeyIterator::next() to iterate through the hash; do not use the iterator if HashKeyIterator::next() returns False. A hash can be iterated in reverse order by calling HashKeyIterator::prev() instead of HashKeyIterator::next()

Example: HashKeyIterator basic usage
  hash data = (
  "key1" : 1,
  "key2" : 2,
  "key3" : 3,
  );
  HashKeyIterator it(data);
  while (it.next()) {
  printf("iter: %n\n", it.getValue());
  }
  iter: "key1"
  iter: "key2"
  iter: "key3"

Note
  - In general, the HashKeyIterator class is not designed to be accessed from multiple threads; it was created without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause an `ITERATOR-THREAD-ERROR` to be thrown.

See also
  HashKeyReverseIterator

## Member Function Documentation

Qore::HashKeyIterator::constructor | ( | hash | h | ) |

Creates the hash iterator object.

Parameters

  h | the hash to iterate

Example:
  HashKeyIterator hi(h);

Qore::HashKeyIterator::constructor | ( |  | ) |

Creates an empty hash iterator object.

Example:
  *hash h = get_hash_or_nothing();
  HashKeyIterator hi(h);

Qore::HashKeyIterator::copy | ( |  | ) |

Creates a copy of the HashKeyIterator object, iterating the same object as the original and in the same position.

Example:
  HashKeyIterator ni = i.copy();

string Qore::HashKeyIterator::getValue | ( |  | ) |

virtual

returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid

Returns
  the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid

Code Flags:
  RET_VALUE_ONLY

Example:
  foreach string key in (hash.keyIterator())
  printf("key: %s\n", key);

Exceptions

  INVALID-ITERATOR | the iterator is not pointing at a valid element
  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Reimplemented from Qore::HashIterator.